"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var Subject_1 = require("rxjs/Subject");
require("rxjs/add/operator/share");
var CURRENTLANGUAGEKEY = 'currentLanguage';
var AppService = /** @class */ (function () {
    function AppService() {
        this.onSubject = new Subject_1.Subject();
        this.currentLangChanges = this.onSubject.asObservable().share();
        this.initializeListening();
    }
    AppService.prototype.ngOnDestroy = function () {
        this.stop();
    };
    AppService.prototype.saveCurrentLanguageInLS = function (currentLanguage) {
        localStorage.setItem(CURRENTLANGUAGEKEY, JSON.stringify(currentLanguage));
        this.onSubject.next(currentLanguage);
    };
    AppService.prototype.initializeListening = function () {
        window.addEventListener('storage', this.storageLangEventListener.bind(this));
    };
    AppService.prototype.storageLangEventListener = function (event) {
        if (event.storageArea.getItem('currentLanguage') == localStorage.getItem(CURRENTLANGUAGEKEY)) {
            var newLanguage = void 0;
            try {
                newLanguage = JSON.parse(event.newValue);
            }
            catch (e) {
                newLanguage = event.newValue;
            }
            this.onSubject.next(newLanguage);
        }
    };
    AppService.prototype.stop = function () {
        window.removeEventListener("storage", this.storageLangEventListener.bind(this));
        this.onSubject.complete();
    };
    AppService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    AppService.ctorParameters = function () { return []; };
    return AppService;
}());
exports.AppService = AppService;
//# sourceMappingURL=app.service.js.map